<script setup lang="ts">
  const { clients, controlledClient, setControlledClient, permissionGranted } = useParticipants();
  const { isGuide } = useUser();
  const { loadLikeList, likeList, likeListCount } = useLikeList();
  const { requestTokenPermission } = useCart();

  const loading = ref(false);

  const selectedParticipant = ref(controlledClient.value);

  const participants = computed(() => [...Object.values(clients.value)]);

  watch(
    selectedParticipant,
    async (participant) => {
      if (isGuide.value && participant) {
        loading.value = true;
        try {
          setControlledClient(participant.attendeeId);
          await loadLikeList();
        } finally {
          loading.value = false;
        }
      }
    },
    {
      immediate: true,
    },
  );
</script>
<template>
  <div class="3xl:max-w-screen-2xl mx-auto max-w-screen-xl bg-white p-8">
    <div class="my-6 flex justify-between">
      <div>
        <h1 class="mb-3 text-[40px] font-bold leading-8">{{ $t('wishlist.header') }}</h1>
        <span class="text-information-subdued">
          {{
            likeListCount === 0 ? $t('cart.noProducts') : $t('cart.products', { p: likeListCount })
          }}
        </span>
      </div>
      <div v-if="isGuide" class="flex items-end gap-4">
        <SwSelect
          v-model="selectedParticipant"
          :options="participants"
          class="min-w-64"
          size="medium"
          label-field="attendeeName"
          key-field="attendeeId"
          return-object-value
          :label="$t('participant')"
          :placeholder="$t('participant')"
        />
        <SwButton
          v-if="!permissionGranted"
          size="large"
          @click="requestTokenPermission(selectedParticipant?.attendeeId)"
          >{{ $t('presentation.participants.requestCartPermission') }}</SwButton
        >
      </div>
    </div>
    <div class="grid grid-cols-1 gap-x-6 gap-y-10 sm:grid-cols-2 lg:grid-cols-4 xl:gap-x-8">
      <LikedProductCard v-for="product in likeList" :key="product.id" :data="product" />
    </div>
  </div>
</template>
